#!/bin/bash

apt-get install wb-mcu-fw-updater -y

systemctl stop config-manager monit data-handler health-monitor wb-rules && pkill wb-mqtt-serial

SERIAL_CFG=$(cat /etc/wb-mqtt-serial.conf)

## Do it on the controller
CFG=$(cat /etc/wb-mqtt-serial.conf)

PORT_COUNT=$(echo $CFG | jq -r ".ports | length")
PORT_MAX="$((PORT_COUNT-1))"

for p in $(seq 0 $PORT_MAX); do
    DEVICE_COUNT=$(echo $CFG | jq -r ".ports[$p].devices | length")
    DEVICE_MAX="$((DEVICE_COUNT-1))"

    for d in $(seq 0 $DEVICE_MAX); do
        DEVICE_TYPE=$(echo $CFG | jq -r ".ports[$p].devices[$d].device_type")
        DEVICE_ID=$(echo $CFG | jq -r ".ports[$p].devices[$d].slave_id")
        MODBUS_PATH=$(echo $CFG | jq -r ".ports[$p].path")
        if [[ "$DEVICE_TYPE" =~ ^(WB-MIR v2|WB-MSW v.3|WB-M1W2|WB-MSW2)$ ]]; then
            echo Will flash $DEVICE_TYPE: $DEVICE_ID
            wb-mcu-fw-updater update-fw $MODBUS_PATH -a$DEVICE_ID
        fi
    done
done

systemctl start config-manager monit data-handler health-monitor wb-rules
sleep 2
ps -aux | grep -E 'serial|health-monitor|wb-rules|data-handler|config-manager|monit'

